//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 8
#property indicator_color1  clrDeepSkyBlue
#property indicator_color2  clrPaleVioletRed
#property indicator_color3  clrDeepSkyBlue
#property indicator_color4  clrPaleVioletRed
#property indicator_color5  clrDeepSkyBlue
#property indicator_color6  clrPaleVioletRed
#property indicator_color7  clrDeepSkyBlue
#property indicator_color8  clrPaleVioletRed
#property indicator_style5  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DOT
#property indicator_style8  STYLE_DOT

//
//
//
//
//

extern int    degree           = 3;
extern double deviations       = 1.5;
extern int    bars             = 250;
extern int    futureBars       = 50;
extern int    calculatingMode  = 0;
extern bool   daysCalculation  = false;
extern int    daysNumber       = 11;

//
//
//
//
//

double regh[],regl[],chnh[],chnl[];
double reghf[],reglf[],chnhf[],chnlf[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   if (daysCalculation && Period()<= PERIOD_D1) bars = daysNumber*PERIOD_D1/Period();
      futureBars = MathMax(MathMin(bars,futureBars),0);
         SetIndexBuffer(0, regh);
         SetIndexBuffer(1, regl);
         SetIndexBuffer(2, chnh);
         SetIndexBuffer(3, chnl);
         SetIndexBuffer(4, reghf); SetIndexShift(4,futureBars);
         SetIndexBuffer(5, reglf); SetIndexShift(5,futureBars);
         SetIndexBuffer(6, chnhf); SetIndexShift(6,futureBars);
         SetIndexBuffer(7, chnlf); SetIndexShift(7,futureBars);
  return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double a[20,20],b[20],c[20],x[20],y[20],s[40];

int start()
{
   int i,k,n; double sum,sumh,suml;

   //
   //
   //
   //
   //

      int tBars = MathMin(bars,Bars-1);
      int d = degree+1; s[1] = tBars+1;

      for(k=1; k<=d*2-2; k++) { sum=0; for(n=0; n<=bars; n++) sum += MathPow(n,k); s[k+1] = sum; }
               switch(calculatingMode)
               {
                     case 1 : for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += High[n] *MathPow(n,k-1); b[k] = sum; }
                              for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Low[n]  *MathPow(n,k-1); c[k] = sum; } break;
                     default: for(k=1; k<=d; k++) { sum=0; for(n=0; n<=bars; n++) sum += Close[n]*MathPow(n,k-1); b[k] = sum; c[k] = sum; }
               }
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, b, x)) return(0);
      for(k=1; k<=d; k++) for(i=1; i<=d; i++) a[i,k]=s[k+i-1]; if (!iCalc(degree+1, a, c, y)) return(0);
      for(k=bars; k>=-futureBars; k--)
      {
            for(i=1,sumh=0,suml=0; i<=degree; i++) { sumh+=x[i+1]*MathPow(k,i); suml+=y[i+1]*MathPow(k,i); }
               if (k<=0) { reghf[k+futureBars] = x[1]+sumh; reglf[k+futureBars] = y[1]+suml; }
               if (k>=0) { regh[k]             = x[1]+sumh; regl[k]             = y[1]+suml; }
      }  
      
      //
      //
      //
      //
      //
      
      double devh = 0; 
      double devl = 0; 
         for(k=0; k<=tBars; k++)
               switch(calculatingMode)
               {
                  case 1 :
                  case 2 : devh += MathPow(High[k] -regh[k],2); 
                           devl += MathPow(Low[k]  -regl[k],2); break;
                  default: devh += MathPow(Close[k]-regh[k],2); 
                           devl = devh;
               }               
         devh = MathSqrt(devh/(tBars+1))*deviations;
         devl = MathSqrt(devl/(tBars+1))*deviations;
             
         //
         //
         //
         //
         //
                      
         for(k=0; k<=tBars; k++)
         {
            chnh[k]=regh[k]+devh;
            chnl[k]=regl[k]-devl;
            if (k<=futureBars)
            {
               chnhf[k]=reghf[k]+devh;
               chnlf[k]=reglf[k]-devl;
            }
         }

   //
   //
   //
   //
   //
   
   SetIndexDrawBegin(0, Bars-tBars-1);
   SetIndexDrawBegin(1, Bars-tBars-1);
   SetIndexDrawBegin(2, Bars-tBars-1); 
   SetIndexDrawBegin(3, Bars-tBars-1); 
   SetIndexDrawBegin(4, Bars-futureBars-1); 
   SetIndexDrawBegin(5, Bars-futureBars-1); 
   SetIndexDrawBegin(6, Bars-futureBars-1); 
   SetIndexDrawBegin(7, Bars-futureBars-1); 
   return(0);
}



//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

bool iCalc(int n, double& aa[][],double& bb[], double& xx[]) 
{
   int i,j,k; double t,q;

   for(k = 1; k <=n-1; k++) 
   {
      int    l = 0; 
      double m = 0; 
         for(i=k; i<=n; i++) 
            if (MathAbs(aa[i,k]) > m) { m = MathAbs(aa[i,k]); l = i; } 
            if (l==0) return(false);   

            //
            //
            //
            
            if(l != k) 
            {
               for(j=1; j<=n; j++) { t = aa[k,j]; aa[k,j] = aa[l,j]; aa[l,j] = t; } 
                                     t = bb[k];   bb[k]   = bb[l];   bb[l]   = t;
            }  
            for(i=k+1; i<=n; i++) 
            {
               q = aa[i,k]/aa[k,k]; 
                  for(j=1; j<=n; j++) 
                    if (j == k)
                           aa[i,j] = 0; 
                    else   aa[i,j] = aa[i,j] - q*aa[k,j];
               bb[i] = bb[i] - q*bb[k];
            }
   }
   
   //
   //
   //
   //
   //
   
      xx[n] = bb[n] / aa[n,n]; 
      for(i=n-1; i>=1; i--) 
      {
         t = 0;  
         for(j = 1; j <= n - i; j++) 
         { 
            t    += aa[i,i+j]*xx[i+j]; 
            xx[i] = (1.0/aa[i,i])*(bb[i]-t);
         }
      }
   return(true);
}

